
#include "ScalesServer.h"

#include <initguid.h>

#include <iostream>
#include <fstream>
#include <conio.h>

using namespace std;


int main( int argc, char *argv[] )
{
   cout << "Initializing COM" << endl;

   if ( FAILED( CoInitialize( NULL )))
   {
      cout << "Unable to initialize COM" << endl;
      return -1;
   }

   char* szProgID = NAME_SCALES_SERVER_BTA;
   WCHAR  szWideProgID[128];
   CLSID  clsid;
   long lLen = MultiByteToWideChar( CP_ACP,
                        0,
                        szProgID,
                        (int)strlen( szProgID ),
                        szWideProgID,
                        sizeof( szWideProgID ) );

   szWideProgID[ lLen ] = '\0';
   HRESULT hr = ::CLSIDFromProgID( szWideProgID, &clsid );
   if ( FAILED( hr ))
   {
      cout.setf( ios::hex, ios::basefield );
      cout << "Unable to get CLSID from ProgID. HR = " << hr << endl;
      return -1;
   }

   IClassFactory* pCF;
   hr = CoGetClassObject( clsid,
                          CLSCTX_INPROC,
                          NULL,
                          IID_IClassFactory,
                          (void**) &pCF );
   if ( FAILED( hr ))
   {
      cout.setf( ios::hex, ios::basefield );
      cout << "Failed to GetClassObject server instance. HR = " << hr << endl;
      return -1;
   }

   IUnknown* pUnk;
   hr = pCF->CreateInstance( NULL, IID_IUnknown, (void**) &pUnk );
   pCF->Release();

   if ( FAILED( hr ))
   {
      cout.setf( ios::hex, ios::basefield );
      cout << "Failed to create server instance. HR = " << hr << endl;
      return -1;
   }

   cout << "Instance created" << endl;

   IScalesServerBTA* pScalesVTA5 = NULL;
   hr = pUnk->QueryInterface( IID_IScalesServerBTA, (LPVOID*)&pScalesVTA5);
   pUnk->Release();
   if ( FAILED( hr ))
   {
      cout << "QueryInterface() for IID_ICScalesVTA5 failed" << endl;
      return -1;
   }
  
   LONG  pPrice=0, pWeight=0, iCost=0, iError=0;
  
  
   wchar_t wComPort[50];
   swprintf(wComPort, sizeof(wComPort)/sizeof(wchar_t), L"%S", (argc <= 1) ? "\\\\.\\COM1" : argv[1]);

   BSTR bstrComPort= SysAllocString(wComPort);
   hr = pScalesVTA5->OpenComPort(bstrComPort, &iError);
   SysFreeString(bstrComPort);

   if ( FAILED( hr ))
   {
      cout << "OpenComPort() failed" << endl;      
   }

   switch(iError)
   {
		case errorOK:		cout << "OpenComPort() OK;" << endl;  
							break;
		default:			cout << "OpenComPort() failed open COM-port" << endl;  
							break;
   };
   

   


   while (!kbhit())
   {
	   hr = pScalesVTA5->GetInfo(&pWeight, &pPrice, &iCost, &iError);
	   if ( FAILED( hr ))
	   {
		  cout << "GetInfo Error." << endl;
		  return -1;
	   }


	   switch(iError)
	   {
			case errorOK:		cout << "W=" << pWeight <<"    P=" << pPrice <<"    C=" << iCost << endl;
								break;

			case errorCOMPort:	cout << "error COM Port" << endl;
								break;

			case errorCOMPortIsClosed:		
								cout << "error COM Port Is Closed" << endl;
								break;

			case errorNotResponce: 
								cout << "Weight not stab OR ='0.000'" << endl;
								break;
	   };

	   
	   Sleep(1000);

	   int r = rand () % 20000;

	   hr = pScalesVTA5->SetPrice(r, &iError);
   }


   hr = pScalesVTA5->CloseComPort(&iError);
   
   if (iError != errorOK)
   {
	   cout << "Error Close COM PORT." << endl;
   }
   
   CoUninitialize();

   return 0;
}
